/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ejbs;

import entities.Address;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaQuery;

/**
 *
 * @author david
 */
@Stateless
public class AddressFacade {
    @PersistenceContext(unitName = "EmeddableProjectPU")
    private EntityManager em;

    public void create(Address address) {
        em.persist(address);
    }

    public void edit(Address address) {
        em.merge(address);
    }

    public void remove(Address address) {
        em.remove(em.merge(address));
    }

    public Address find(Object id) {
        return em.find(Address.class, id);
    }

    public List<Address> findAll() {
        CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
//        CriteriaQuery cq = em.getQueryBuilder().createQuery();
        cq.select(cq.from(Address.class));
        return em.createQuery(cq).getResultList();
    }

    public List<Address> findRange(int[] range) {
        CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
//        CriteriaQuery cq = em.getQueryBuilder().createQuery();
        cq.select(cq.from(Address.class));
        Query q = em.createQuery(cq);
        q.setMaxResults(range[1] - range[0]);
        q.setFirstResult(range[0]);
        return q.getResultList();
    }

    public int count() {
        return ((Long) em.createQuery("select count(o) from Address as o").getSingleResult()).intValue();
    }

}
